{ tetbol1.inc, Subroutinen Initialisierungsteil fr Tetrabol:   }
{ screenfarben,aufblenden,abblenden,holeimages,initstructures   }

procedure screenfarben;  { setzt RGB-Farben in die Farbregister }
const pal:array[0..pred(maxcol),0..2] of word=
          (( 0,12,20),(60,60,60),( 0,23,28),(54,36,31),
           (43,20,20),(61,24,24),(63,29, 0),(60,36, 0),
           (25,34,53),(12,34,12),( 0,35,29),( 0,27,34),
           (42,20,32),(34,24,33),(26,26,26),(44,26,26));
var i:integer;
begin
   for i:=0 to pred(maxcol) do setrgbpalette(i,pal[i,0],pal[i,1],pal[i,2])
end;

procedure abblenden;  { frbt alles background }
var i:integer;
begin
   for i:=1 to pred(maxcol) do setpalette(i,0)
end;

procedure aufblenden;  { frbt alles ein }
var i:integer;
begin
   for i:=0 to pred(maxcol) do setpalette(i,i)
end;

{ --------------------------------------------------------------------- }

procedure holeimages(var ok:boolean);
var f          :file;
    i,j,k,ii,jj:integer;
    anz,size   :word;
begin
{ Grafik einlesen und anzeigen mit ima[0]: }
   size:=0;
   assign(f,imafil);
   reset(f,1);
   if ioresult=0 then begin
      BlockRead(f,ima[0],sizeof(Image),anz);
      if anz=sizeof(Image) then with ima[0] do begin
         size:=ImageSize(1,1,width,height);
         GetMem(p_data,size);
         BlockRead(f,p_data^,size,anz);
         PutImage(0,0,p_data^,normalput);
         Freemem(p_data,size);
      end;
      close(f);
   end;
   ok:=size>0; 

{ Images ima [0..65] pflcken: }
{ Masken-Images auf 0-3, Dreiecke folgen, zuletzt Rand und Extras }
{ Maske ist oben links, daneben 4 Dreieckfelder, danach Rand      }
{ darunter 2 Zeilen a 5 Dreiecksfelder, danach Extra-Steine       }
   if ok then begin
      k:=0;
      size:=Imagesize(1,1,dx,dy);
      for jj:=0 to 2 do for ii:=0 to 4 do
      for j:=0 to 1 do for i:=0 to 1 do begin
         with ima[k] do begin
            x:=0; y:=0; width:=dx; height:=dy;
            getmem(p_data,size);
            getimage(ii*32+i*dx,jj*32+j*dy,
                     ii*32+i*dx+pred(dx),jj*32+j*dy+pred(dy),p_data^);
            p_nextimage:=nil;
         end;
         inc(k);
      end;
      ii:=5*32;
      for j:=0 to 5 do begin { 60-65: Block,Block,Tilt,Kreuz,Bonus,Bombe }
         with ima[k] do begin
            x:=0; y:=0; width:=dx; height:=dy;
            getmem(p_data,size);
            getimage(ii,j*dy,ii+pred(dx),j*dy+pred(dy),p_data^);
            p_nextimage:=nil;
         end;
         inc(k);
      end;
   end;
end;

{ --------------------------------------------------------------------- }

procedure initstructures;
{ initialisiert die Gadgets Neu, Ende, den Header und den Footer }
{ Gadgets auf Index 1 und 2, Header auf 3 und Footer auf 4       }
var i,j,k:integer;
begin
   itext1[1].IText:=' voll';
   itext1[2].Itext:='Sound';
   itext1[3].IText:=' Neu ';
   itext1[4].IText:=' Ende';
   itext1[5].IText:=titel;
   itext1[6].IText:='-----';
   itext1[7].IText:=' halb';
   itext1[8].IText:='Punkte:';
   itext1[9].Itext:='Quiet';

   for i:=1 to 6 do begin
      { Border belegen: }
      k:=15;
      case i of
      1..4: j:=47;
         5: j:=623;
         6: j:=431;
      end;
      xy1[i,0]:=0;  xy1[i,1]:=k; xy1[i,2]:=xy1[i,0]; xy1[i,3]:=0;
      xy1[i,4]:=j;  xy1[i,5]:=xy1[i,3];
      xy2[i,0]:=0;  xy2[i,1]:=k; xy2[i,2]:=j; xy2[i,3]:=k;
      xy2[i,4]:=j;  xy2[i,5]:=1;

      with ibord1[i] do begin
         x:=0; y:=0; fpen:=1; bpen:=2; drmode:=jam1; ecken:=3;
         p_ecken:=addr(xy1[i]);
         p_nextborder:=addr(ibord2[i]);
      end;
      with ibord2[i] do begin
         x:=0; y:=0; fpen:=0; bpen:=2; drmode:=jam1; ecken:=3;
         p_ecken:=addr(xy2[i]);
         p_nextborder:=nil;
      end;

      { IntuiTexte belegen: }
      with itext1[i] do begin
         x:=5; y:=4; fpen:=1; bpen:=3; drmode:=jam2;
         p_nexttext:=addr(itext2[i]);
      end;
      with itext2[i] do begin
        x:=4; y:=4; fpen:=0; bpen:=3; drmode:=jam1;
        itext:=itext1[i].itext;
        p_nexttext:=nil;
      end;

      { Gadgets initialisieren, Header und Footer gehoeren aus daten- }
      { praktisch-technischen Grnden mit dazu (einfacher zu updaten) }
      with igad[i] do begin
         case i of
         1..4: begin
                x:=392+i*48; y:=460; width:=48;
             end;
          5: begin
                x:=8; y:=4; width:=624;
             end;
          6: begin
                x:=8; y:=460; width:=432;
             end;
         end;
         id:=i;                          height:=16;
         bpen:=3;                        hibpen:=15;
         p_loborder:=addr(ibord1[i]);    p_hiborder:=p_loborder;
         p_loimage:=nil;                 p_hiimage:=p_loimage;
         p_lointuitext:=addr(itext1[i]); p_hiintuitext:=p_lointuitext;
         gadgettyp:=boolgadget;
         onoff:=false;
         active:=true;
         p_specialinfo:=nil;
         if i=1 then begin
            p_hiintuitext:=addr(itext1[7]);
            onoff:=true
         end;
         if i=2 then begin
            p_lointuitext:=addr(itext1[9]);
            hibpen:=3; bpen:=15;
            onoff:=true
         end;
         if i<6 then p_nextgadget:=addr(igad[succ(i)])
         else p_nextgadget:=nil;
      end;
   end;

   itext1[6].x:=16;
   itext2[6].x:=pred(itext1[6].x);
   for i:=7 to 9 do begin
      with itext1[i] do begin
         x:=5; y:=4; fpen:=1; bpen:=3; drmode:=jam2;
         p_nexttext:=addr(itext2[i]);
      end;
      with itext2[i] do begin
         x:=4; y:=4; fpen:=0; bpen:=3; drmode:=jam1;
         itext:=itext1[i].itext;
         p_nexttext:=nil;
      end;
   end;
end;

{ --------------------------------------------------------------------- }
