{ tetbol2.inc, Steincodierungen fr Tetrabol  }
{ 30.10.94: ok von Stein 1 bis 29 von 77, symmetrische Elemente }
{ 10.11.94: ok von Stein 1 bis 69 von 77 }

procedure initsteine;
var i,j,k:integer;
begin
   for i:=0 to 79 do with stein[i] do begin { Werte initialisieren: }
      id:=i; x:=0; y:=0; turn:=0; flip:=0;
      for j:=0 to 3 do begin
         xi[j]:=0; yi[j]:=0; qi[j]:=0;
      end;
   end;

   { 1 Quadrat, ima 4 - 7: }
   with stein[1] do begin
      xi[0]:=0;     xi[1]:=1;   xi[2]:=0;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=1;   yi[3]:=1;
      qi[0]:=4;     qi[1]:=5;   qi[2]:=6;   qi[3]:=7;
      flip:=1;
      turn:=1;
   end;

   { 4 Rechtecke, ima 4 - 7: }
   with stein[2] do begin
      xi[0]:=0;     xi[1]:=0;   xi[2]:=0;   xi[3]:=0;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=1;   yi[3]:=1;
      qi[0]:=6;     qi[1]:=5;   qi[2]:=6;   qi[3]:=5;
      flip:=4;
      turn:=3;
   end;
   with stein[3] do begin
      xi[0]:=0;     xi[1]:=0;   xi[2]:=1;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=0;   yi[3]:=0;
      qi[0]:=4;     qi[1]:=7;   qi[2]:=4;   qi[3]:=7;
      flip:=5;
      turn:=2;
   end;
   with stein[4] do begin
      xi[0]:=0;     xi[1]:=0;   xi[2]:=0;   xi[3]:=0;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=1;   yi[3]:=1;
      qi[0]:=4;     qi[1]:=7;   qi[2]:=4;   qi[3]:=7; 
      flip:=2;
      turn:=3;
   end;
   with stein[5] do begin
      xi[0]:=0;     xi[1]:=0;   xi[2]:=1;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=0;   yi[3]:=0;
      qi[0]:=6;     qi[1]:=5;   qi[2]:=6;   qi[3]:=5;
      flip:=3;
      turn:=2;
   end;

   { 4 Rauten, ima 8 - 11: }
   with stein[6] do begin
      xi[0]:=0;     xi[1]:=1;   xi[2]:=1;   xi[3]:=2;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=0;   yi[3]:=0;
      qi[0]:=10;    qi[1]:=9;   qi[2]:=10;  qi[3]:=9;
      flip:=8;
      turn:=7;
   end;
   with stein[7] do begin
      xi[0]:=0;     xi[1]:=0;   xi[2]:=0;   xi[3]:=0;
      yi[0]:=0;     yi[1]:=1;   yi[2]:=1;   yi[3]:=2;
      qi[0]:=8;     qi[1]:=11;  qi[2]:=8;   qi[3]:=11;
      flip:=9;
      turn:=6;
   end;
   with stein[8] do begin
      xi[0]:=0;     xi[1]:=1;   xi[2]:=1;   xi[3]:=2;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=0;   yi[3]:=0;
      qi[0]:=8;     qi[1]:=11;  qi[2]:=8;   qi[3]:=11;
      flip:=6;
      turn:=9;
   end;
   with stein[9] do begin
      xi[0]:=0;     xi[1]:=0;   xi[2]:=0;   xi[3]:=0;
      yi[0]:=0;     yi[1]:=1;   yi[2]:=1;   yi[3]:=2;
      qi[0]:=9;     qi[1]:=10;  qi[2]:=9;   qi[3]:=10;
      flip:=7;
      turn:=8;
   end;

   { 4 lange Rauten, ima 12 - 15: }
   with stein[10] do begin
      xi[0]:=1;     xi[1]:=0;   xi[2]:=1;   xi[3]:=0;
      yi[0]:=0;     yi[1]:=1;   yi[2]:=1;   yi[3]:=2;
      qi[0]:=12;    qi[1]:=12;  qi[2]:=15;  qi[3]:=15;
      flip:=12;
      turn:=11;
   end;
   with stein[11] do begin
      xi[0]:=0;     xi[1]:=1;   xi[2]:=1;   xi[3]:=2;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=1;   yi[3]:=1;
      qi[0]:=14;    qi[1]:=13;  qi[2]:=14;  qi[3]:=13;
      flip:=13;
      turn:=10;
   end;
   with stein[12] do begin
      xi[0]:=0;     xi[1]:=0;   xi[2]:=1;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=1;   yi[2]:=1;   yi[3]:=2;
      qi[0]:=13;    qi[1]:=14;  qi[2]:=13;  qi[3]:=14;
      flip:=10;
      turn:=13;
   end;
   with stein[13] do begin
      xi[0]:=0;     xi[1]:=1;   xi[2]:=1;   xi[3]:=2;
      yi[0]:=1;     yi[1]:=0;   yi[2]:=1;   yi[3]:=0;
      qi[0]:=12;    qi[1]:=12;  qi[2]:=15;  qi[3]:=15;
      flip:=11;
      turn:=12;
   end;

   { 4 Dreiecke, ima 16 - 19: }
   with stein[14] do begin
      xi[0]:=0;     xi[1]:=0;   xi[2]:=0;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=1;   yi[3]:=0;
      qi[0]:=19;    qi[1]:=16;  qi[2]:=19;  qi[3]:=19;
      flip:=15;
      turn:=15;
   end;
   with stein[15] do begin
      xi[0]:=0;     xi[1]:=1;   xi[2]:=1;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=0;   yi[3]:=1;
      qi[0]:=18;    qi[1]:=18;  qi[2]:=17;  qi[3]:=18;
      flip:=14;
      turn:=16;
   end;
   with stein[16] do begin
      xi[0]:=0;     xi[1]:=1;   xi[2]:=1;   xi[3]:=1;
      yi[0]:=1;     yi[1]:=0;   yi[2]:=1;   yi[3]:=1;
      qi[0]:=16;    qi[1]:=16;  qi[2]:=16;  qi[3]:=19;
      flip:=17;
      turn:=17;
   end;
   with stein[17] do begin
      xi[0]:=0;     xi[1]:=0;   xi[2]:=0;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=1;   yi[2]:=1;   yi[3]:=1;
      qi[0]:=17;    qi[1]:=17;  qi[2]:=18;  qi[3]:=17;
      flip:=16;
      turn:=14;
   end;

   { 4 Pfeile, ima 20 - 23: }
   with stein[18] do begin
      xi[0]:=0;     xi[1]:=1;   xi[2]:=0;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=1;   yi[3]:=1;
      qi[0]:=20;    qi[1]:=21;  qi[2]:=23;  qi[3]:=22;
      flip:=18;
      turn:=19;
   end;
   with stein[19] do begin
      xi[0]:=0;     xi[1]:=1;   xi[2]:=0;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=1;   yi[3]:=1;
      qi[0]:=22;    qi[1]:=21;  qi[2]:=20;  qi[3]:=23;
      flip:=21;
      turn:=20;
   end;
   with stein[20] do begin
      xi[0]:=0;     xi[1]:=1;   xi[2]:=0;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=1;   yi[3]:=1;
      qi[0]:=21;    qi[1]:=20;  qi[2]:=22;  qi[3]:=23;
      flip:=20;
      turn:=21;
   end;
   with stein[21] do begin
      xi[0]:=0;     xi[1]:=1;   xi[2]:=0;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=1;   yi[3]:=1;
      qi[0]:=20;    qi[1]:=23;  qi[2]:=22;  qi[3]:=21;
      flip:=19;
      turn:=18;
   end;


   { 4 Schwalben, ima 24 - 27: }
   with stein[22] do begin
      xi[0]:=0;     xi[1]:=0;   xi[2]:=1;   xi[3]:=0;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=0;   yi[3]:=1;
      qi[0]:=25;    qi[1]:=26;  qi[2]:=25;  qi[3]:=26;
      flip:=23;
      turn:=23;
   end;
   with stein[23] do begin
      xi[0]:=0;     xi[1]:=1;   xi[2]:=1;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=0;   yi[3]:=1;
      qi[0]:=24;    qi[1]:=27;  qi[2]:=24;  qi[3]:=27;
      flip:=22;
      turn:=24;
   end;
   with stein[24] do begin
      xi[0]:=1;     xi[1]:=0;   xi[2]:=1;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=1;   yi[2]:=1;   yi[3]:=1;
      qi[0]:=25;    qi[1]:=26;  qi[2]:=25;  qi[3]:=26;
      flip:=25;
      turn:=25;
   end;
   with stein[25] do begin
      xi[0]:=0;     xi[1]:=0;   xi[2]:=0;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=1;   yi[2]:=1;   yi[3]:=1;
      qi[0]:=24;    qi[1]:=27;  qi[2]:=24;  qi[3]:=27;
      flip:=24;
      turn:=22;
   end;


   { 4 Wellen, ima 28 - 31: }
   with stein[26] do begin
      xi[0]:=0;     xi[1]:=1;   xi[2]:=1;   xi[3]:=2;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=1;   yi[3]:=1;
      qi[0]:=28;    qi[1]:=29;  qi[2]:=30;  qi[3]:=31;
      flip:=28;
      turn:=27;
   end;
   with stein[27] do begin
      xi[0]:=1;     xi[1]:=0;   xi[2]:=1;   xi[3]:=0;
      yi[0]:=0;     yi[1]:=1;   yi[2]:=1;   yi[3]:=2;
      qi[0]:=29;    qi[1]:=28;  qi[2]:=31;  qi[3]:=30;
      flip:=29;
      turn:=26;
   end;
   with stein[28] do begin
      xi[0]:=1;     xi[1]:=2;   xi[2]:=0;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=1;   yi[3]:=1;
      qi[0]:=28;    qi[1]:=29;  qi[2]:=30;  qi[3]:=31;
      flip:=26;
      turn:=29;
   end;
   with stein[29] do begin
      xi[0]:=0;     xi[1]:=0;   xi[2]:=1;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=1;   yi[2]:=1;   yi[3]:=2;
      qi[0]:=28;    qi[1]:=30;  qi[2]:=29;  qi[3]:=31;
      flip:=27;
      turn:=28;
   end;

{ --- }

   { 8 Trapeze, ima 32 - 35: }
   with stein[30] do begin
      xi[0]:=0;     xi[1]:=1;   xi[2]:=1;   xi[3]:=2;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=0;   yi[3]:=0;
      qi[0]:=32;    qi[1]:=33;  qi[2]:=34;  qi[3]:=33;
      flip:=34;
      turn:=31;
   end;
   with stein[31] do begin
      xi[0]:=0;     xi[1]:=0;   xi[2]:=0;   xi[3]:=0;
      yi[0]:=0;     yi[1]:=1;   yi[2]:=1;   yi[3]:=2;
      qi[0]:=33;    qi[1]:=35;  qi[2]:=32;  qi[3]:=35;
      flip:=37;
      turn:=32;
   end;
   with stein[32] do begin
      xi[0]:=0;     xi[1]:=1;   xi[2]:=1;   xi[3]:=2;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=0;   yi[3]:=0;
      qi[0]:=34;    qi[1]:=33;  qi[2]:=34;  qi[3]:=35;
      flip:=36;
      turn:=33;
   end;
   with stein[33] do begin
      xi[0]:=0;     xi[1]:=0;   xi[2]:=0;   xi[3]:=0;
      yi[0]:=0;     yi[1]:=1;   yi[2]:=1;   yi[3]:=2;
      qi[0]:=32;    qi[1]:=35;  qi[2]:=32;  qi[3]:=34;
      flip:=35;
      turn:=30;
   end;

   with stein[34] do begin
      xi[0]:=0;     xi[1]:=1;   xi[2]:=1;   xi[3]:=2;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=0;   yi[3]:=0;
      qi[0]:=32;    qi[1]:=35;  qi[2]:=32;  qi[3]:=33;
      flip:=30;
      turn:=35;
   end;
   with stein[35] do begin
      xi[0]:=0;     xi[1]:=0;   xi[2]:=0;   xi[3]:=0;
      yi[0]:=0;     yi[1]:=1;   yi[2]:=1;   yi[3]:=2;
      qi[0]:=33;    qi[1]:=34;  qi[2]:=33;  qi[3]:=35;
      flip:=33;
      turn:=36;
   end;
   with stein[36] do begin
      xi[0]:=0;     xi[1]:=1;   xi[2]:=1;   xi[3]:=2;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=0;   yi[3]:=0;
      qi[0]:=34;    qi[1]:=35;  qi[2]:=32;  qi[3]:=35;
      flip:=32;
      turn:=37;
   end;
   with stein[37] do begin
      xi[0]:=0;     xi[1]:=0;   xi[2]:=0;   xi[3]:=0;
      yi[0]:=0;     yi[1]:=1;   yi[2]:=1;   yi[3]:=2;
      qi[0]:=32;    qi[1]:=34;  qi[2]:=33;  qi[3]:=34;
      flip:=31;
      turn:=34;
   end;

 { --- das Visier, Objekte  38 - 45, Images 36 - 39 --- }

   with stein[38] do begin
      xi[0]:=0;     xi[1]:=1;   xi[2]:=0;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=1;   yi[3]:=1;
      qi[0]:=36;    qi[1]:=37;  qi[2]:=38;  qi[3]:=38;
      flip:=42;
      turn:=39;
   end;
   with stein[39] do begin
      xi[0]:=0;     xi[1]:=1;   xi[2]:=0;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=1;   yi[3]:=1;
      qi[0]:=36;    qi[1]:=37;  qi[2]:=36;  qi[3]:=39;
      flip:=45;
      turn:=40;
   end;
   with stein[40] do begin
      xi[0]:=0;     xi[1]:=1;   xi[2]:=0;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=1;   yi[3]:=1;
      qi[0]:=37;    qi[1]:=37;  qi[2]:=38;  qi[3]:=39;
      flip:=44;
      turn:=41;
   end;
   with stein[41] do begin
      xi[0]:=0;     xi[1]:=1;   xi[2]:=0;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=1;   yi[3]:=1;
      qi[0]:=36;    qi[1]:=39;  qi[2]:=38;  qi[3]:=39;
      flip:=43;
      turn:=38;
   end;

   with stein[42] do begin
      xi[0]:=0;     xi[1]:=1;   xi[2]:=0;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=1;   yi[3]:=1;
      qi[0]:=36;    qi[1]:=37;  qi[2]:=39;  qi[3]:=39;
      flip:=38;
      turn:=43;
   end;
   with stein[43] do begin
      xi[0]:=0;     xi[1]:=1;   xi[2]:=0;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=1;   yi[3]:=1;
      qi[0]:=38;    qi[1]:=37;  qi[2]:=38;  qi[3]:=39;
      flip:=41;
      turn:=44;
   end;
   with stein[44] do begin
      xi[0]:=0;     xi[1]:=1;   xi[2]:=0;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=1;   yi[3]:=1;
      qi[0]:=36;    qi[1]:=36;  qi[2]:=38;  qi[3]:=39;
      flip:=40;
      turn:=45;
   end;
   with stein[45] do begin
      xi[0]:=0;     xi[1]:=1;   xi[2]:=0;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=1;   yi[3]:=1;
      qi[0]:=36;    qi[1]:=37;  qi[2]:=38;  qi[3]:=37;
      flip:=39;
      turn:=42;
   end;

 { --- der Helm, Objekte  46 - 53, Images 40 - 43 --- }

   with stein[46] do begin
      xi[0]:=0;     xi[1]:=1;   xi[2]:=0;   xi[3]:=0;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=1;   yi[3]:=1;
      qi[0]:=40;    qi[1]:=41;  qi[2]:=43;  qi[3]:=40;
      flip:=50;
      turn:=47;
   end;
   with stein[47] do begin
      xi[0]:=0;     xi[1]:=0;   xi[2]:=1;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=0;   yi[3]:=1;
      qi[0]:=41;    qi[1]:=42;  qi[2]:=41;  qi[3]:=43;
      flip:=53;
      turn:=48;
   end;
   with stein[48] do begin
      xi[0]:=1;     xi[1]:=1;   xi[2]:=0;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=1;   yi[3]:=1;
      qi[0]:=43;    qi[1]:=40;  qi[2]:=42;  qi[3]:=43;
      flip:=52;
      turn:=49;
   end;
   with stein[49] do begin
      xi[0]:=0;     xi[1]:=0;   xi[2]:=1;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=1;   yi[2]:=1;   yi[3]:=1;
      qi[0]:=40;    qi[1]:=42;  qi[2]:=41;  qi[3]:=42;
      flip:=51;
      turn:=46;
   end;

   with stein[50] do begin
      xi[0]:=0;     xi[1]:=1;   xi[2]:=1;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=1;   yi[3]:=1;
      qi[0]:=40;    qi[1]:=41;  qi[2]:=41;  qi[3]:=42;
      flip:=46;
      turn:=51;
   end;
   with stein[51] do begin 
      xi[0]:=1;     xi[1]:=0;   xi[2]:=0;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=1;   yi[2]:=1;   yi[3]:=1;
      qi[0]:=41;    qi[1]:=43;  qi[2]:=40;  qi[3]:=43;
      flip:=49;
      turn:=52;
   end;
   with stein[52] do begin
      xi[0]:=0;     xi[1]:=0;   xi[2]:=0;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=1;   yi[3]:=1;
      qi[0]:=41;    qi[1]:=42;  qi[2]:=42;  qi[3]:=43;
      flip:=48;
      turn:=53;
   end;
   with stein[53] do begin
      xi[0]:=0;     xi[1]:=1;   xi[2]:=1;   xi[3]:=0;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=0;   yi[3]:=1;
      qi[0]:=40;    qi[1]:=43;  qi[2]:=40;  qi[3]:=42;
      flip:=47;
      turn:=50;
   end;

 { --- das Kopftuch, Objekte  54 - 61, Images 44 - 47 --- }

   with stein[54] do begin
      xi[0]:=0;     xi[1]:=1;   xi[2]:=0;   xi[3]:=0;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=1;   yi[3]:=1;
      qi[0]:=44;    qi[1]:=47;  qi[2]:=47;  qi[3]:=44;
      flip:=58;
      turn:=55;
   end;
   with stein[55] do begin
      xi[0]:=0;     xi[1]:=0;   xi[2]:=1;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=0;   yi[3]:=1;
      qi[0]:=45;    qi[1]:=46;  qi[2]:=45;  qi[3]:=46;
      flip:=61;
      turn:=56;
   end;
   with stein[56] do begin
      xi[0]:=1;     xi[1]:=1;   xi[2]:=0;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=1;   yi[3]:=1;
      qi[0]:=44;    qi[1]:=47;  qi[2]:=44;  qi[3]:=47;
      flip:=60;
      turn:=57;
   end;
   with stein[57] do begin
      xi[0]:=0;     xi[1]:=0;   xi[2]:=1;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=1;   yi[2]:=1;   yi[3]:=1;
      qi[0]:=45;    qi[1]:=46;  qi[2]:=45;  qi[3]:=46;
      flip:=59;
      turn:=54;
   end;

   with stein[58] do begin
      xi[0]:=0;     xi[1]:=1;   xi[2]:=1;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=1;   yi[3]:=1;
      qi[0]:=46;    qi[1]:=45;  qi[2]:=45;  qi[3]:=46;
      flip:=54;
      turn:=59;
   end;
   with stein[59] do begin
      xi[0]:=1;     xi[1]:=0;   xi[2]:=0;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=1;   yi[2]:=1;   yi[3]:=1;
      qi[0]:=44;    qi[1]:=47;  qi[2]:=44;  qi[3]:=47;
      flip:=57;
      turn:=60;
   end;
   with stein[60] do begin
      xi[0]:=0;     xi[1]:=0;   xi[2]:=0;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=1;   yi[3]:=1;
      qi[0]:=45;    qi[1]:=46;  qi[2]:=46;  qi[3]:=45;
      flip:=56;
      turn:=61;
   end;
   with stein[61] do begin
      xi[0]:=0;     xi[1]:=1;   xi[2]:=1;   xi[3]:=0;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=0;   yi[3]:=1;
      qi[0]:=44;    qi[1]:=47;  qi[2]:=44;  qi[3]:=47;
      flip:=55;
      turn:=58;
   end;

 { --- die Pommestte, Objekte  62 - 69, Images 48 - 51 --- }

   with stein[62] do begin
      xi[0]:=0;     xi[1]:=0;   xi[2]:=0;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=1;   yi[2]:=1;   yi[3]:=1;
      qi[0]:=48;    qi[1]:=51;  qi[2]:=48;  qi[3]:=49;
      flip:=66;
      turn:=63;
   end;
   with stein[63] do begin
      xi[0]:=0;     xi[1]:=0;   xi[2]:=1;   xi[3]:=0;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=0;   yi[3]:=1;
      qi[0]:=49;    qi[1]:=50;  qi[2]:=49;  qi[3]:=51;
      flip:=69;
      turn:=64;
   end;
   with stein[64] do begin
      xi[0]:=0;     xi[1]:=1;   xi[2]:=1;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=0;   yi[3]:=1;
      qi[0]:=50;    qi[1]:=51;  qi[2]:=48;  qi[3]:=51;
      flip:=68;
      turn:=65;
   end;
   with stein[65] do begin
      xi[0]:=1;     xi[1]:=0;   xi[2]:=1;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=1;   yi[2]:=1;   yi[3]:=1;
      qi[0]:=48;    qi[1]:=50;  qi[2]:=49;  qi[3]:=50;
      flip:=67;
      turn:=62;
   end;

   with stein[66] do begin
      xi[0]:=1;     xi[1]:=0;   xi[2]:=1;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=1;   yi[2]:=1;   yi[3]:=1;
      qi[0]:=49;    qi[1]:=48;  qi[2]:=49;  qi[3]:=50;
      flip:=62;
      turn:=67;
   end;
   with stein[67] do begin 
      xi[0]:=0;     xi[1]:=0;   xi[2]:=0;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=1;   yi[2]:=1;   yi[3]:=1;
      qi[0]:=49;    qi[1]:=51;  qi[2]:=48;  qi[3]:=51;
      flip:=65;
      turn:=68;
   end;
   with stein[68] do begin
      xi[0]:=0;     xi[1]:=0;   xi[2]:=1;   xi[3]:=0;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=0;   yi[3]:=1;
      qi[0]:=49;    qi[1]:=50;  qi[2]:=51;  qi[3]:=50;
      flip:=64;
      turn:=69;
   end;
   with stein[69] do begin
      xi[0]:=0;     xi[1]:=1;   xi[2]:=1;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=0;   yi[3]:=1;
      qi[0]:=48;    qi[1]:=51;  qi[2]:=48;  qi[3]:=50;
      flip:=63;
      turn:=66;
   end;

 { --- der Pferdekopf, Objekte  70 - 77, Images 52 - 55 --- }

   with stein[70] do begin
      xi[0]:=1;     xi[1]:=2;   xi[2]:=0;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=1;   yi[3]:=1;
      qi[0]:=52;    qi[1]:=53;  qi[2]:=52;  qi[3]:=55;
      flip:=74;
      turn:=71;
   end;
   with stein[71] do begin
      xi[0]:=0;     xi[1]:=0;   xi[2]:=1;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=1;   yi[2]:=1;   yi[3]:=2;
      qi[0]:=53;    qi[1]:=54;  qi[2]:=53;  qi[3]:=55;
      flip:=77;
      turn:=72;
   end;
   with stein[72] do begin
      xi[0]:=1;     xi[1]:=2;   xi[2]:=0;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=1;   yi[3]:=1;
      qi[0]:=52;    qi[1]:=55;  qi[2]:=54;  qi[3]:=55;
      flip:=76;
      turn:=73;
   end;
   with stein[73] do begin
      xi[0]:=0;     xi[1]:=0;   xi[2]:=1;   xi[3]:=1;
      yi[0]:=0;     yi[1]:=1;   yi[2]:=1;   yi[3]:=2;
      qi[0]:=52;    qi[1]:=54;  qi[2]:=53;  qi[3]:=54;
      flip:=75;
      turn:=70;
   end;

   with stein[74] do begin
      xi[0]:=0;     xi[1]:=1;   xi[2]:=1;   xi[3]:=2;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=1;   yi[3]:=1;
      qi[0]:=52;    qi[1]:=53;  qi[2]:=54;  qi[3]:=53;
      flip:=70;
      turn:=75;
   end;
   with stein[75] do begin
      xi[0]:=1;     xi[1]:=0;   xi[2]:=1;   xi[3]:=0;
      yi[0]:=0;     yi[1]:=1;   yi[2]:=1;   yi[3]:=2;
      qi[0]:=53;    qi[1]:=52;  qi[2]:=55;  qi[3]:=55;
      flip:=73;
      turn:=76;
   end;
   with stein[76] do begin
      xi[0]:=0;     xi[1]:=1;   xi[2]:=1;   xi[3]:=2;
      yi[0]:=0;     yi[1]:=0;   yi[2]:=1;   yi[3]:=1;
      qi[0]:=54;    qi[1]:=53;  qi[2]:=54;  qi[3]:=55;
      flip:=72;
      turn:=77;
   end;
   with stein[77] do begin
      xi[0]:=1;     xi[1]:=0;   xi[2]:=1;   xi[3]:=0;
      yi[0]:=0;     yi[1]:=1;   yi[2]:=1;   yi[3]:=2;
      qi[0]:=52;    qi[1]:=52;  qi[2]:=55;  qi[3]:=54;
      flip:=71;
      turn:=74;
   end;

   { --- uff, geschafft! --- }

end;

{ --------------------------------------------------------------------- }
