program Tetrabol;
{ UJAs Tetrix mit Dreiecken, nach gleicher mathematischer Vorschrift    }
{ 23.10.94: Chip- und Colordesign, Datenstruktur Chips und Spielfeld    }
{ 30.10.94: Screendesign, HSC-Anzeige, Spielfeld, Chips 1 - 29          }
{ 01.11.94: Screenaufbau und Anzeigen, Chipinitialisierung, Hngt-Check }
{           rechts, links, turn, flip, drop, dropall, Punkteverwaltung  }
{           Spieler 1: Pfeilt., 0, f, astein, 1. spielbare V.0.80 alpha }
{           o:Anzeige, p:Pause, h:halber Chipsatz, t:sound on/off       }
{ 03.11.94: Levelcount, ansteigende Geschwindigkeit, Reihen updaten,    }
{           Pausentaste, Sound ein/aus, halber Chipsatz:  V.0.90 alpha  }
{ 08.11.94: Turn, Rechts, Links optimiert, Schraege    :  V.0.91 alpha  }
{ 10.11.94: restliche Steine samt Test, Normalisierung :  V.0.92 alpha  }

{ noch zu tun: 2.Spieler (wasy1), levels entwerfen }

uses crt,graph,dos,drivers,intuit,hiscore;

const
   xmax=10; ymax=20; dx=16; dy=16; ox=80; oy=64; maxchip=40; maxcol=16;
   einfach=10;       reihe=50;     bonus=250;    runde=100;
   startspeed=10;
   imafil='Tetrabol.ima';
   hscfil='Tetrabol.hsc';  
   titel =' *  U J A s   T e t r a b o l   *  V.0.92 alpha - 11/94 *  TP6 *';


type
   feld=array[-1..(xmax+2),-1..(ymax+2)] of integer;   { Flip, Turn }
   chip=record
             x,y,id,turn,flip:integer;
             xi,yi,qi         :array[0..3] of integer;
         end;

var                                              { Global }
   ima          :array[0..65] of Image;
   igad         :array[1..6]  of Gadget;
   xy1,xy2      :array[1..6]  of Koords;
   ibord1,ibord2:array[1..6]  of Border;
   itext1,itext2:array[1..9]  of IntuiText;
   hsc          :HighScore;
   gerade,ungerade                    :feld;
   punkte                             :longint;
   event                              :tevent;

   ok,fettich,fini,ende,anzeige,soundon     :boolean;       { lokal }
   ch,ch1,ch2                               :char;
   level,steinno,chipno,key,mx,my,ig,i,count,haengtan,speed:integer;
   stein                                    :array[0..79] of chip;
   astein,bstein                            :chip;
   levelname                                :string;

{ ========================================================================= }
{$i tetbol1.inc } { screenfarben,aufblenden,abblenden,holeimages,initstruct }
{$i tetbol2.inc } { Steincodierungen fr Stein 1 - 77, bisher: 29  }
{$i tetbol3.inc } { Anzeigen und Zeichnen des Screen, der Figueren }

procedure zeichneelement(x,y:integer);
var i:integer;
begin
rectfill(ox+x*dx,oy+y*dy,ox+x*dx+pred(dx),oy+y*dy+pred(dy),2);
i:=gerade[x,y];
if i in [1..59] then begin
   putimage(ox+x*dx,oy+y*dy,ima[i mod 4].p_data^,andput);
   putimage(ox+x*dx,oy+y*dy,ima[i].p_data^,orput);
end else if i in [60..65]
    then putimage(ox+x*dx,oy+y*dy,ima[i].p_data^,normalput);
i:=ungerade[x,y];
if i in [1..59] then begin
   putimage(ox+x*dx,oy+y*dy,ima[i mod 4].p_data^,andput);
   putimage(ox+x*dx,oy+y*dy,ima[i].p_data^,orput);
end;
end;

{ --- }


{ ---- ab hier Spielverlauf ----------------------------------------------- }

function haengt(astein:chip):integer;
var k,l,m,h:integer;
begin
   h:=99;
   with astein do for k:=0 to 3 do begin
      l:=gerade[x+xi[k],y+yi[k]];
      m:=ungerade[x+xi[k],y+yi[k]];
      if l>=60 then begin { quadratische Steine }
         if h>l then h:=l;
      end;
      if l>0 then begin { Symmetrie mit gerader Kennung (0,2) }
         if ((l mod 4)=0) and ((qi[k] mod 4)<>3) then h:=qi[k];
         if ((l mod 4)=2) and ((qi[k] mod 4)<>1) then h:=qi[k];
      end;
      if m>0 then begin {   Symm. mit ungerader Kennung (1,3) }
         if ((m mod 4)=1) and ((qi[k] mod 4)<>2) then h:=qi[k];
         if ((m mod 4)=3) and ((qi[k] mod 4)<>0) then h:=qi[k];
      end;
   end;
   if h=99 then haengt:=0 else haengt:=h
end;

{ --- }
procedure dropsaeule(x,y:integer);
var j:integer;
    fettich:boolean;
begin
j:=y;
fettich:=false;
while not fettich do begin
   fettich:=j=0;
   if not fettich then begin
      fettich:=gerade[x,pred(j)]=60;
      if fettich then begin
         gerade[x,j]:=0;
         ungerade[x,j]:=0;
      end else begin
         gerade[x,j]:=gerade[x,pred(j)];
         ungerade[x,j]:=ungerade[x,pred(j)];
         dec(j)
      end;
   end;
end;
for j:=0 to y do zeichneelement(x,j)
end;




procedure checkreihe(var punkte:longint);
var i,j,k       :integer;
    voll,gueltig:boolean;
begin
   for j:=ymax downto 0 do begin
      voll:=true;
      gueltig:=false;
      for i:=1 to xmax do begin
         if gerade[i,j]=0 then voll:=false;
         if ungerade[i,j]=0 then voll:=false;
         if not gueltig then
         gueltig:=(gerade[i,j] in [1..55]) or (ungerade[i,j] in [1..55])
      end;
      voll:=voll and gueltig;
      if voll then begin
         punkte:=punkte+reihe;
         for i:=1 to xmax do begin
            if gerade[i,j]=61 then punkte:=punkte+bonus;
            if gerade[i,j] in [1..59,61..64] then dropsaeule(i,j);
         end;
      end;
   end;
end;

{ --- }


procedure startechip(chipanzeige:boolean;
                     var next:integer; var astein:chip; var voll:boolean);
var i,j,k:integer;
begin
astein:=stein[next];
randomize;
if igad[1].onoff then k:=64 else k:=112;
k:=succ(random(10000) mod k);
case k of
 0..  7: next:=1;             { das Quadrat         }
 8.. 63: next:=(k-4) div 2;   { die symmetrischen   }
64..111: next:=k-34;          { die unsymmetrischen }
end;

if chipanzeige then zeichneanzeige(stein[next]);
astein.x:=succ(random(10000) mod (xmax-2));
astein.y:=0;
zeichnechip(ox,oy,astein);
voll:=haengt(astein)>0;
end;

{ --- }

procedure drop(var astein:chip; var haengtan:integer);
begin
   with astein do begin
      inc(y);
      haengtan:=haengt(astein);
      dec(y);
      if haengtan=0 then begin
         loeschechip(ox,oy,astein);
         inc(y);
         zeichnechip(ox,oy,astein);
      end;
   end;
end;

{ --- }

procedure dropall(var astein:chip; var haengtan:integer);
var i:integer;
begin
   haengtan:=0;
   with astein do begin
      while haengtan=0 do drop(astein,haengtan);
   end;
end;

{ --- }

procedure rechts(var astein:chip);
var fettich:boolean; bstein:chip;
begin
   bstein:=astein;
   with astein do begin
      bstein.x:=succ(x);
      fettich:=haengt(bstein)>0;
      if fettich then if y<ymax then begin { noch ein Versuch mit Drop }
         bstein.y:=succ(y);
         fettich:=haengt(bstein)>0;
      end;
      if not fettich then begin
         loeschechip(ox,oy,astein);
         astein:=bstein;
         zeichnechip(ox,oy,astein);
      end;
   end;
end;

{ --- }

procedure links(var astein:chip);
var fettich:boolean;
    bstein :chip;
begin
   bstein:=astein;
   with astein do begin
      bstein.x:=pred(x);
      fettich:=haengt(bstein)>0;
      if fettich then if y<ymax then begin { noch ein Versuch mit Drop }
         bstein.y:=succ(y);
         fettich:=haengt(bstein)>0;
      end;
      if not fettich then begin
         loeschechip(ox,oy,astein);
         astein:=bstein;
         zeichnechip(ox,oy,astein);
      end;
   end;
end;

{ --- }

procedure flip(var astein:chip);
var fettich:boolean; bstein:chip;
begin
   with astein do begin
      bstein:=stein[flip];
      bstein.x:=x;
      bstein.y:=y;
      fettich:=haengt(bstein)>0;
      if not fettich then begin
         loeschechip(ox,oy,astein);
         zeichnechip(ox,oy,bstein);
         astein:=bstein;
      end;
   end;
end;

{ --- }

procedure turn(var astein:chip);
var fettich:boolean; i:integer;  bstein:chip;
begin
   with astein do begin
      bstein:=stein[turn];
      bstein.x:=x;
      bstein.y:=y;
      fettich:=haengt(bstein)>0;
      if fettich then if x>0 then begin   { noch ein Versuch mit x-1 }
         bstein.x:=pred(x);
         fettich:=haengt(bstein)>0;
         if fettich then if x>1 then begin   { noch ein Versuch mit x-2 }
            bstein.x:=x-2;
            fettich:=haengt(bstein)>0;
         end;
      end;

      if not fettich then begin
         loeschechip(ox,oy,astein);
         zeichnechip(ox,oy,bstein);
         astein:=bstein;
      end;
   end;
end;




{ ===================================================================== }

begin
   initscreen(ok);
   screenfarben;
   if ok then begin
      abblenden;       
      holeimages(ok);
      initstructures;
      initsteine;
      ende:=false;
      loadhighscore(hscfil,hsc);
      aufblenden;
      zeichnescreen;
{ 1. Chip generieren: }
      randomize;
      if igad[1].onoff then steinno:=21 else steinno:=37;
      steinno:=succ(random(10000) mod steinno);
      initevents;
      soundon:=true;
      while not ende do begin
         level:=0;
         getlevel(level,levelname);
         initlevel(level,levelname,chipno,fini);  
         punkte:=0;
         showhighscore(hsc,376,256,12,14,6,0,2);
         speed:=startspeed;

         { Main Loop }
         while not (fini or ende) do begin
            startechip(true,steinno,astein,fini);
            if not fini then begin
               punkte:=punkte+einfach;
               punktanzeige(punkte);
               inc(chipno);
            end;
            fettich:=fini;
            count:=0;

            repeat
               showmouse;
               inc(count);
               delay(speed);
               getmouseevent(event);
               hidemouse;
               while keypressed do begin
                  ch:=readkey;
                  if ch=chr(0) then begin { Steuertasten: }
                     ch:=readkey;
                     case ch of
                     #72: turn(astein);
                     #75: links(astein);
                     #77: rechts(astein);
                     #80: begin
                             if soundon then sound(50);
                             dropall(astein,haengtan);
                             fettich:=haengtan>0;
                             if soundon then nosound;
                          end;
                     end;
                  end else begin
                     ende:=ende or (ch=#27);
                     ch:=upcase(ch);
                     case ch of
                     '0','F': flip(astein);
                     'H': begin
                             igad[1].onoff:=not igad[1].onoff;
                             DrawGadget(addr(igad[1]));
                          end;
                     'O': begin
                             anzeige:=not anzeige;
                             if anzeige then zeichneanzeige(stein[steinno])
                             else loescheanzeige;
                          end;
                     'P': begin
                             showmouse;
                             repeat
                                delay(50);
                                getmouseevent(event)
                             until keypressed or (event.what=evmouseup);
                          end;
                     'T': begin
                             soundon:=not soundon;
                             igad[2].onoff:=soundon;
                             DrawGadget(addr(igad[2]));
                          end;
               {      '1': flip(bstein);
                     'W': turn(bstein);
                     'A': links(bstein);
                     'S': rechts(bstein);
                     'Y': begin
                             if soundon then sound(50);
                             dropall(bstein,haengtan);
                             fettich:=haengtan>0;
                             if soundon then nosound;
                          end;   }
                     end;
                  end;
               end;   { key-Events }

               if event.what=evmouseup then begin { Maustaste losgelassen }
                  getmousexy(key,mx,my);
                  ig:=checkgadget(addr(igad[1]),mx,my);
                  case ig of
                  1: begin
                        igad[ig].onoff:=not igad[ig].onoff;
                        DrawGadget(addr(igad[ig]));
                     end;
                  2: begin
                        igad[ig].onoff:=not igad[ig].onoff;
                        DrawGadget(addr(igad[ig]));
                        soundon:=igad[ig].onoff;
                     end;
                  3: fini:=true;
                  4: ende:=true;
                  end;
               end else if count>50 then begin    { alle 50 Tics ein Drop}
                  if soundon then sound(50);
                  drop(astein,haengtan);
                { drop(bstein,haengtan); }
                  fettich:=haengtan>0;
                  count:=0;
                  if soundon then nosound;
               end;

            until fettich or fini or ende;

            { Stein verankern: }
            if fettich then begin
               inc(chipno);
               if chipno mod 10=0 then if speed>2 then dec(speed);
               with astein do for i:=0 to 3 do
               if odd(qi[i]) then ungerade[x+xi[i],y+yi[i]]:=qi[i]
                               else gerade[x+xi[i],y+yi[i]]:=qi[i];
               case haengtan of
               1..61: checkreihe(punkte);  { Steine, Block, Bonus }
        {       62   : bomba(astein);
               63   : tilt(astein,fini);         }
               end;
            end;
            if chipno>100 then begin
               inc(level);
               punkte:=punkte+1000*level;
               punktanzeige(punkte);
               getlevel(level,levelname);
               initlevel(level,levelname,chipno,fini);
               speed:=startspeed;
            end;

         end;
         updathighscore(punkte,hscfil,hsc,376,256,12,3,1,0,2);

      end;
      doneevents;
      CloseGraph;
   end;
end.

